<?php
/* this script renders the photos on the fly for img_view.php */
require_once('sql/db_api.php');

/* try to increase memory_limit */
ini_set("memory_limit", "64M");

/* try remove php script time limit of 30 sec */
set_time_limit(0);

$convert=read_config('use_convert');
unset($src_file);

$prev_path = stripslashes($_GET['prev_path']);
$filename = stripslashes($_GET['filename']);
$name = stripslashes($_GET['name']);

$src_file=$prev_path."/".$filename;

list($org_width,$org_height,$org_type) = getimagesize("$src_file");

if($convert)
{
	/* get img quality level from config*/
	$img_quality=read_config('img_quality');

	/* TODO remove as of 1.0 */
	if(empty($img_quality)):$img_quality="75";endif;

	$img_quality_str="-quality $img_quality";

	/* tmp file stuff */
	$tmp_file_org = tempnam("/tmp", "$filename");
	$tmp_file=$tmp_file_org.".jpg";
	unlink("$tmp_file_org");

	exec("convert $img_quality_str -size \"".$_GET['new_width']."x".$_GET['new_height']."\" \"$src_file\" -sample \"".$_GET['new_width']."x".$_GET['new_height']."\" +profile APP1 \"$tmp_file\"");
	$scaled_image = fread(fopen("$tmp_file", "rb"), filesize("$tmp_file"));

	/* rotate image for printing */
	if($_GET['cfp'] && $_GET['rotate'])
	{
		$scaled_image="$tmp_file";
		exec("convert -rotate 90 $scaled_image \"$tmp_file.rotated\"");
		$scaled_image = fread(fopen("$tmp_file.rotated", "rb"), filesize("$tmp_file.rotated"));
	}

	/* get rid of magic_quotes */
	if(get_magic_quotes_runtime()==1)
	{
		$scaled_image=stripslashes($scaled_image);
	}

	header("Content-Type: image/jpeg");
	echo $scaled_image;

	/* remove convert created file*/
	unlink("$tmp_file");
	unlink("$tmp_file.rotated");
	unset($scaled_image);
}
/* workarround for Mac OSX where convert is usually installed in /sw/bin */
elseif($convert==1 && file_exists("/sw/bin/convert"))
{
	/* get img quality level from config*/
	$img_quality=read_config('img_quality');

	/* TODO remove as of 1.0 */
	if(empty($img_quality)):$img_quality="75";endif;

	$img_quality_str="-quality $img_quality";

	/* tmp file stuff */
	$tmp_file_org = tempnam("/tmp", "$filename");
	$tmp_file=$tmp_file_org.".jpg";
	unlink("$tmp_file_org");
	
	exec("/sw/bin/convert $img_quality_str -size \"".$_GET['new_width']."x".$_GET['new_height']."\" \"$src_file\" -sample \"".$_GET['new_width']."x".$_GET['new_height']."\" +profile APP1 \"/tmp/$filename\"");
	$scaled_image = fread(fopen("/tmp/$filename", "rb"), filesize("/tmp/$filename"));

		/* rotate image for printing */
		if($_GET[cfp] && $_GET[rotate])
			{
			$scaled_image="/tmp/$filename";
			exec("/sw/bin/convert -rotate 90 $scaled_image \"/tmp/rotated.$filename\"");
			$scaled_image = fread(fopen("/tmp/rotated.$filename", "rb"), filesize("/tmp/rotated.$filename"));
			}

	/* get rid of magic_quotes */
	if(get_magic_quotes_runtime()==1)
	{
		$scaled_image=stripslashes($scaled_image);
	}

	header("Content-Type: image/jpeg");
	echo $scaled_image;

	/* remove convert created file*/
	unlink("/tmp/$filename");
	unlink("/tmp/rotated.$filename");
	unset($scaled_image);
}
else
{
	switch($org_type)
	{
		case 1: $image_type=imagecreatefromgif("$src_file"); break;
		case 2: $image_type=imagecreatefromjpeg("$src_file"); break;
		case 3: $image_type=imagecreatefrompng("$src_file"); break;
		default: $image_type=imagecreatefromjpeg("$src_file"); break;
	}

	if ($image_type)
	{
		/* ask config for GD version */
		$gd_current=read_config('gd_version');
		switch($gd_current)
		{
			case ">2":
				$scaled_image=imagecreatetruecolor($_GET['new_width'],$_GET['new_height']);
				break;
			case "<2":
				$scaled_image=imagecreate($_GET['new_width'],$_GET['new_height']);
				break;
			default:
				$scaled_image=imagecreate($_GET['new_width'],$_GET['new_height']);
				break;
		}
		if ($scaled_image && read_config('thumb_quality')==true)
		{
			/* create HQ thumbnails using imagecopyresampled() */
			imagecopyresampled($scaled_image,$image_type,0,0,0,0,
					$_GET['new_width'],$_GET['new_height'],
					$org_width,$org_height);
			imagedestroy($image_type);
		}
		elseif($scaled_image)
		{
			imagecopyresized($scaled_image,$image_type,0,0,0,0,
					$_GET['new_width'],$_GET['new_height'],
					$org_width,$org_height);
			imagedestroy($image_type);
		}

		/* rotate for printing */
		if($_GET['cfp'] && $_GET['rotate'])
			{
				$scaled_image=imagerotate($scaled_image,90,0);
			}

		switch($org_type)
		{
			case 1:
			header("Content-Type: image/gif");
			imagegif($scaled_image);
			break;
			case 2:
			header("Content-Type: image/jpeg");
			imagejpeg($scaled_image);
			break;
			case 3:
			header("Content-Type: image/png");
			imagepng($scaled_image);
			break;
			default:
			header("Content-Type: image/jpeg");
			imagejpeg($scaled_image);
			break;
		}
		imagedestroy($scaled_image);
	}
}/*end else*/
?>
