<?php
include("header.php");
require_once('sql/db_connect.php');
require_once('sql/db_api.php');

/* session stuff */
session_start();
if(session_is_registered("user_name") && session_is_registered("user_pass"))
{
	$passed=true;
	if ($_SESSION["REMOTE_ADDR"]!=$_SERVER["REMOTE_ADDR"])
	{
		$passed=false;
	}
	/* ip check went wrong! */
	if (!$passed)
	{
		unset($_SESSION['user_name'], $_SESSION['user_pass'], $_SESSION['user_level']);
		session_destroy();
	}
}

$first_name = stripslashes($_GET['first_name']);
$sec_name = stripslashes($_GET['sec_name']);
$prev_path = stripslashes($_GET['prev_path']);
$filename = stripslashes($_GET['filename']);
$name = stripslashes($_GET['name']);
$_SESSION[alb] = !empty($_GET[alb])?$_GET[alb]:$_SESSION[alb];

/* include rotating. needs to be placed here to make sure we will see an
up to date view after rotating... */
include("actions/rotate.php");

/*receive image information */
list($org_width,$org_height,$org_type) = getimagesize("{$prev_path}/{$filename}");

$max_width = read_config("photo_width");
$max_height = read_config("photo_height");

$div_width  = $org_width  / $max_width;
$div_height = $org_height / $max_height;

/*portrait/landscape?*/
if ($div_width >= $div_height)
{
	$new_width = $max_width;
	$new_height = round($org_height /$div_width);
	/* $a $b used later in image_resized_view.php call */
	$a="new_width";
	$b="new_height";
}else
{
	$new_width =  round($org_width / $div_height);
	$new_height = $max_height;
	/* $a $b used later in image_resized_view.php call */
	$a="new_height";
	$b="new_width";
}

/* use mini previews of next/prev image as buttons ? */
$mini_preview=read_config("mini_preview");

/* lets see who called us */
if($_GET['came_from_search']):
	$append="&search={$_GET['search']}&path={$_GET['path']}
	&photo_query={$_GET['photo_query']}&came_from_search=1";endif;

/* standard url */
$url_link="prev_path=".urlencode($prev_path)."
			&name=".urlencode($name)."&filename=".urlencode($filename)."&new_width=$new_width&new_height=$new_height
			&alb={$_GET['alb']}&first_name=".urlencode($first_name)."&sec_name=".urlencode($sec_name)."&page={$_GET['page']}";

/*#############################################
## create left view / receive thumbnail
#############################################*/

print("<tr bgcolor='#CCCCCC'>");
print("<td valign='top' background='graphics/menu_backg.gif'><div align='center'><b>$img_detail</b></div>");
print("<div align='center'>");
print("<img src='get_thumbs.php?name=".urlencode($name)."&filename=".urlencode($filename)."
			&prev_path=".urlencode($prev_path)."' alt='thumbnail' border='0'>");

/*###############################################
## Include EXIF info.
## This may either be included EXIF extension of PHP (default) OR the
## LinPHA-exifer plugin. (written by Jake Olefsky)
###############################################*/

/* exif verbosity level */
$exif_level=read_config("exif_level");

/* exif by default !? */
if(read_config("exif_default"))
{
	$exif=1;
	$exif_default=1;
}else
{
	$exif=$_GET["exif"];
}

/* enable exif ? */
if(read_config('exifinfo'))
{
	/* PHP itself has EXIF support and version >=4.2.0*/
	if(extension_loaded('exif') && check_php_version("4.2.0"))
	{
			include_once("actions/read_php_exif.php");
	}
	/* is the exifer plugin installed ? */
	elseif(file_exists("plugins/exifer/exif.php"))
	{
		include_once("actions/read_exif.php");
	}
	else
	{
		print("<br><font size='-2'><b>$img_size</b>: $org_width x $org_height</font>");
		print("<br><font size='-2'><b>$img_name</b>: {$filename}</font><br><hr>");
	}
}
/* EXIF disabled! just display filename and image dimension */
else
{
	print("<br><font size='-2'><b>$img_size</b>: $org_width x $org_height</font>");
	print("<br><font size='-2'><b>$img_name</b>: {$filename}</font><br><hr>");
}

/*###############################################
## slideshow select field
###############################################*/
$enable_slide=read_config("slideshow");

/* TODO remove as of 1.0 */
if(strlen($enable_slide)<1):
		$enable_slide=1;
		write_config(slideshow, 1);endif;

if($enable_slide)
{
	if(!$_GET['slide'])
	{
		print("<form name=slide action='$PHP_SELF' method='GET'>");
		print("<select name=time size=1 style='width:120'>");
		print("<option value='5000'>$slideshow</option>");
		print("<option value='5000'>5 $seconds</option>");
		print("<option value='10000'>10 $seconds</option>");
		print("<option value='15000'>15 $seconds</option>");
		print("<option value='20000'>20 $seconds</option>");
		print("<option value='25000'>25 $seconds</option>");
		print("</select>&nbsp;<input type='submit' value='$go'>");

		print("<input type=hidden name=first_name value='{$_GET['first_name']}'>");
		print("<input type=hidden name=sec_name value='{$_GET['sec_name']}'>");
		print("<input type=hidden name=page value='{$_GET['page']}'>");
		print("<input type=hidden name=alb value='{$_GET['alb']}'>");
		print("<input type=hidden name=exif value='$exif'>");
		print("<input type=hidden name=prev_path value='{$prev_path}'>");
		print("<input type=hidden name=name value='{$name}'>");
		print("<input type=hidden name=filename value='{$filename}'>");
		print("<input type=hidden name=slide value='1'>");
		print("<hr></form>");
	}else
	{
		print("<form name='stopslide' action='$PHP_SELF' method='GET'>");
		print("<input type=hidden name=first_name value='{$_GET['first_name']}'>");
		print("<input type=hidden name=sec_name value='{$_GET['sec_name']}'>");
		print("<input type=hidden name=page value='{$_GET['page']}'>");
		print("<input type=hidden name=alb value='{$_GET['alb']}'>");
		print("<input type=hidden name=exif value='$exif'>");
		print("<input type=hidden name=prev_path value='{$prev_path}'>");
		print("<input type=hidden name=name value='{$name}'>");
		print("<input type=hidden name=filename value='{$filename}'>");
		print("<input type=hidden name=slide value='0'>");
		print("<input type='submit' name='stop' value='$stopslide'><hr></form>");
	}
}
/*#############################################
## admin check
#############################################*/
if(session_is_registered("user_name") && session_is_registered("user_pass"))
{
	/* category/comments/description info*/
	print("<form name='description' method=GET action='actions/store_comment.php'>");
	//prev_path=$prev_path&name=$name&filename=$filename'>");

	/* if there isn't already an entry, display just all values from category */
	print("<label><b>$img_cat</b></label><br>");
	if(strlen($category_entry = read_description("category", $name, $filename, $prev_path))<2)
	{
		print("<select name='category_name' size='1' style='width:180'>");
		get_category(); print("</select><br>");
	}else
	/* make sure to print entry from photos as first value in select and the rest below*/
	{
	print("<select name='category_name' size='1' style='width:180'>");
	print("<option value='$category_entry'>");
	echo $category_entry; print("</option>");
	get_category();
	print("</option></select><br>");
	}

	/* description */
	print("<label><b>$img_des</b></label><br>");
	$desript = read_description("descr", $name, $filename, $prev_path);
	print("<input type='text' name='descr' length='22' maxlength='25'
			value='$desript' style='width:180'><br>");

	/* comment */
	print("<label><b>$img_com</b></label><br>");
	if(empty($exif_comment)):
	$exif_comment=read_description("comment", $name, $filename, $prev_path);endif;
	print("<font size='-2'><textarea name='comment' cols='20' rows='4' style='width:180'>$exif_comment</textarea></font><br>");

	/* submit required vars to store_comment.php */
	print("<input type=hidden name=first_name value='{$first_name}'>");
	print("<input type=hidden name=sec_name value='{$sec_name}'>");
	print("<input type=hidden name=page value='{$_GET['page']}'>");
	print("<input type=hidden name=alb value='{$_GET['alb']}'>");
	print("<input type=hidden name=exif value='$exif'>");
	print("<input type=hidden name=prev_path value='".urlencode($prev_path)."'>");
	print("<input type=hidden name=name value='".urlencode($name)."'>");
	print("<input type=hidden name=filename value='".urlencode($filename)."'>");
	print("<input type=submit name='add_info' value='Submit'>");
	print("<input type=hidden name=alb value='{$_SESSION['alb']}'>");
	print("</form>");
	print("<hr>");
	/* comments saved msg...*/
	echo "{$_GET['info']}";
}
else /* NOT admin */
{
	/*
	print("<label><b>$img_cat</b></label><br>");
	$category=read_description(category, $name, $filename, $prev_path);
	echo "$category";
	*/
	print("<br><label><b>$img_des</b></label><br>");
	$descript=read_description(descr, $name, $filename, $prev_path);
	print("<input type='text' name='descr' length='22' maxlength='25'
			value='$descript' readonly='readonly' style='width:170'><br>");

	print("<br><label><b>$img_com</b></label><br>");
	if(empty($exif_comment)):
	$exif_comment=read_description(comment, $name, $filename, $prev_path);endif;
	print("<textarea name='comment' cols='19' rows='4' readonly='readonly' style='width:170'>$exif_comment</textarea><br>");
	print("<br><hr>");
	print("<br>$please_login");
}
/* create href */
/* back to search */
if($_GET['came_from_search'])
{
	$photo_query=stripslashes($_GET['photo_query']);
	print("<p><a href='search.php?search={$_GET['search']}&path={$_GET['path']}
			&photo_query=$photo_query
			&came_from_img_view=1'>
			<font color='#000099'>$back_to_search</font></a></p>");
}
else
{
/* back to thumbnails message */
print("<p><a href='$_SESSION[alb]_stage_album.php?prev_path=".urlencode($prev_path)."
		&first_name=".urlencode($first_name)."
		&sec_name=".urlencode($sec_name)."
		&name=".urlencode($name)."&action=search
		&page_number=$_GET[page]&exif={$_GET['exif']} class='searchlink'>
		<font color='#000099'>$back_to_thumbs</font></a></p>");
}
print("</div>");

/*#############################################
## main view
#############################################*/
/* query selected photo, beware of thumbnail order */

$thumb_order=read_config('sort_thumbs');
if($thumb_order=="date")
{
	$order_by="date DESC";
}
else
{
	$order_by="filename";
}

$query=mysql_query("SELECT name, filename, date FROM {$GLOBALS["table_prefix"]}photos
					WHERE name='".addslashes($name)."' AND prev_path='".addslashes($prev_path)."'
					ORDER BY $order_by ");

$number=mysql_num_rows($query);
$count=0;

while($row=mysql_fetch_row($query))
{
	$count++;
	if($row[1]==$filename)
	{
		$previous=$count-1;
		$current=$count;
		$next=$count+1;
	}
}

/* query previous photo name*/
$query_prev=mysql_query("SELECT name, filename FROM {$GLOBALS["table_prefix"]}photos
							WHERE name='".addslashes($name)."' AND prev_path='".addslashes($prev_path)."'
							ORDER BY $order_by");
$count=0;

while($row=mysql_fetch_row($query_prev))
{
	$count++;
	if($count==$previous)
	{
		$prev_img=$row[1];
		break;
	}
}

/* query next photo name*/
$query_next=mysql_query("SELECT name, filename FROM {$GLOBALS["table_prefix"]}photos
							WHERE name='".addslashes($name)."' AND prev_path='".addslashes($prev_path)."'
							ORDER BY $order_by ");
$count=0;

while($row=mysql_fetch_row($query_next))
{
	$count++;
	if($count==$next)
	{
		$next_img=$row[1];
		break;
	}
}

/* create main view */
$bgcolor=color_switch(read_config("style"), "tablecolor");
$fontcol=color_switch(read_config("style"), "fontcolor")
;
print("<td height='100%' colspan='2' bgcolor='$bgcolor'>");
print("<table align='center'>");
print("<tr><td>");

/* href to previous photo */
if(!empty($previous))
{
	print("<a href='img_view.php?prev_path=".urlencode($prev_path)."
			&name=".urlencode($name)."&filename=".urlencode($prev_img)."&new_width=$new_width&new_height=$new_height
			&alb={$_GET['alb']}&first_name={$_GET['first_name']}&sec_name={$_GET['sec_name']}&page={$_GET['page']}
			&exif={$_GET['exif']}&$append&photo_query={$_GET['photo_query']}'>");

	if($mini_preview) //use previous image as button ?
	{
		print("<div align='center'><img src='get_thumbs.php?name=".urlencode($name)."&filename=".urlencode($prev_img)."
				&prev_path=".urlencode($prev_path)."' alt='thumbnail' border='0' width='40' height='30'>
				<br>$button_prev</div></a>");
	}
	else
	{
		print("<div align='center'><img src='graphics/back.gif' alt='previous image' width=32 height=32 border=0>
				<br>$button_prev</div></a>");
	}
}
print("</td>");

/* store/read number of views in DB */
$no_views = write_views($prev_path,$filename);

/* current photo */
print("<td align='center'><font color='$fontcol'>");
printf("$detail_header $current $detail_header1 $number $detail_header2");
print("<div align='right'>$no_views $views</div>");
print("<img src='get_thumbs_on_fly.php?prev_path=".urlencode($prev_path)."&filename=".urlencode($filename)."
			&new_width=$new_width&new_height=$new_height'
			width='$new_width' height='$new_height' border='1'</a><br>");

/* hrefs to 640x480 /800x600 / fullsize */
print("$view_at :<a href='actions/image_resized_view.php?prev_path=".urlencode($prev_path)."&filename=".urlencode($filename)."
		&$a=640&$b=480' target='_blank'>&nbsp;[640x480]</a>");
print("<a href='actions/image_resized_view.php?prev_path=".urlencode($prev_path)."&filename=".urlencode($filename)."
		&$a=800&$b=600' target='_blank'>&nbsp;[800x600]</a>");
print("<a href='actions/image_resized_view.php?prev_path=".urlencode($prev_path)."&filename=".urlencode($filename)."
		&new_width=$org_width&new_height=$org_height'  target='_blank'>&nbsp;[$img_size]</a>");

/*###############################################
## stuff for image rotating
## make sure image is writeable and if GD is used, PHP is >=4.3.0
## (earlier versions do NOT support imagerotate() )
###############################################*/
$img_rotation=read_config('img_rotation');

if(session_is_registered("user_name") && session_is_registered("user_pass") && $img_rotation)
{
	/* make sure image directory and the image itself are writeable!
	if not, disable rotating and display warning/hint (we receive this info
	from rotate.php) + If GD lib is used make sure it >= 4.3.0*/
	$use_convert=read_config('use_convert');

	if($img_is_writeable && $use_convert)
	{
		$can_rotate=true;
	}elseif($img_is_writeable && !$use_convert && check_php_version("4.3.0"))
	{
		$can_rotate=true;
	}else
	{
		$can_rotate=false;
	}

	if($can_rotate) /* OK, requirements fit! */
	{
		print("<br><a href='$PHP_SELF?prev_path=".urlencode($prev_path)."
					&name=".urlencode($name)."&filename=".urlencode($filename)."&$a=$new_width&$b=$new_height
					&alb={$_GET['alb']}&first_name={$_GET['first_name']}&sec_name={$_GET['sec_name']}&page={$_GET['page']}
					&exif={$_GET['exif']}&$append&photo_query={$_GET['photo_query']}&rotate=left'>
					<img src='graphics/rotate_left.png' alt='left' border='0'></a>");

		print("&nbsp;&nbsp;<b>..:: $img_rotate_ok ::..&nbsp;</b>");

		print("<a href='$PHP_SELF?prev_path=".urlencode($prev_path)."
					&name=".urlencode($name)."&filename=".urlencode($filename)."&new_width=$new_height&new_height=$new_width
					&alb={$_GET['alb']}&first_name={$_GET['first_name']}&sec_name={$_GET['sec_name']}&page={$_GET['page']}
					&exif={$_GET['exif']}&$append&photo_query={$_GET['photo_query']}&rotate=right'>
					<img src='graphics/rotate_right.png' alt='right' border='0'></a>");
	}else
	{
		/* display the error msg and provide help button*/
		print("<br><b>..:: $img_rotating_hint1");
		putHelpButton('docs/index.php?chapter=imgrotate');
		print("&nbsp;$img_rotating_hint2 ::..</b>");
	}
}

print("</font></td>");

/* href to next photo */
print("<td>");
if(!empty($next_img))
{
	print("<a href='img_view.php?prev_path=".urlencode($prev_path)."
			&name=".urlencode($name)."&filename=".urlencode($next_img)."&new_width=$new_width&new_height=$new_height
			&alb={$_GET['alb']}&first_name={$_GET['first_name']}&sec_name={$_GET['sec_name']}&page={$_GET['page']}
			&exif={$_GET['exif']}&$append&photo_query=$photo_query'>");
	if($mini_preview) //use previous image as button ?
	{
		print("<div align='center'><img src='get_thumbs.php?name=".urlencode($name)."&filename=".urlencode($next_img)."
				&prev_path=".urlencode($prev_path)."' alt='thumb' border='0' width='40' height='30'>
				<br>$button_next</div></a>");
	}else
	{
		print("<div align='center'><img src='graphics/forward.gif' alt='next image' width=32 height=32 border=0>
			<br>$button_next</div></a>");
	}
}
print("</td></tr>");
print("</table>");
print("</td></tr>");

/* slideshow */
if($_GET['slide'] && $number!=$current)
{
print("<script language='javascript'>
		<!--
		var redirected = ' $PHP_SELF?prev_path={$prev_path}&name={$name}&filename=$next_img&alb={$_GET['alb']}&first_name={$_GET['first_name']}&sec_name={$_GET['sec_name']}&page={$_GET['page']}&exif={$_GET['exif']}&$append&photo_query=$photo_query&slide=1&time={$_GET[time]}';
		function redirect() {
		window.location = redirected ;
		}
		setTimeout('redirect()', $_GET[time]);
		// -->
		</script>");
}

/*  reset... */
unset($came_from_search);

include('footer.php');
?>

