<?php

include_once('sql/db_connect.php');
global $table_prefix;

/*#############################################################
## some functions to calculate the page rendering time, this is
## very useful while trying to speed up LinPHA :-)
#############################################################*/

function get_render_time()
{
list ($usec, $sec)=explode(" ", microtime());
return ((float)$usec + (float)$sec);
}

/* start timer */
function start_timer()
{
global $timer;
$timer=get_render_time();
}

/* stop timer */
function stop_timer()
{
global $timer;
echo number_format(get_render_time()-$timer,4);
}

/*#############################################################
## count number of albums/subfolders. This is used in *_stage_album to
## align the subfolder preview and photos "top" if number of albums
## is > 15 to prevent scrolling (If you have many albums you have to scroll down
## to see the contend as it is aligned middle... (SF feature request)
#############################################################*/

function content_align($level_1, $level_2, $level_3)
{
	/* max number of folders */
	$limit=15;

	if($level_1>=$limit || $level_2>=$limit || $level_3>=$limit)
	{
		$align="valign='top'";
	}else
	{
		$align="valign='center'";
	}

	return $align;
}

/*#############################################################
## create help icon and define href...
## This is used during install and at all admin pages
#############################################################*/

function putHelpButton($page, $linkBody = false)
{
print ("<script language='javascript'><!--
function showHelp(topic) {
	top.newWin = window.open(topic, \"help\",
	\"dependent=yes,width=700,height=500,titlebar=yes,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no\");
	top.newWin.focus();
}
//--></script>");

$img= 'graphics/help.png';
echo '<a href="javascript:showHelp(\''. $page .	'\');">
	<img src="' . $img . '" border=0>' . $linkBody . '</a>';
}

/*#############################################################
## security check to recognize URL changes (albums/ MUST be first in prev_path= !!)
## TODO we have to take care of "../" values also...
#############################################################*/

function check_path($first_path)
{
/* security */
$pathcheck=explode("/", "$first_path");
if($pathcheck[0]!="albums"):
	echo "Hey, what do you think you are doing? <br> trying to hack me??";endif;
}

/*#############################################################
## the magic of language auto-detection
## this alows us to welcome users with their natural language if already available
#############################################################*/

function get_http_accept_lang($http_accept_language)
{
  /* Accept-Language Header detail, see RFC2616 */
  $knownlangs = array( "dk" => "Danish",
						"nl"	=> "Dutch",
						"en"	=> "English",
						"de"	=> "German",
						"ja"	=> "Japanese",
						"it"	=> "Italian",
						"es"	=> "Spanish",
						"co"	=> "Spanish",
						"fr"	=> "French",
						"no"	=> "Norwegian",
						"pt"	=> "BrazilianPortuguese",
						"br"	=> "BrazilianPortuguese",
						"zh"	=> "zh-tw",
						"tw"	=> "zh-tw" );

  $accept_lang = 'English';
  $lastquality = 0.0;

  $langtag = '((?:[a-zA-Z]{1,8})(?:-[a-zA-Z]{1,8})*)';
  $qvalue ='(0(?:\.[0-9]{1,3})?|1(?:\.0{1,3}))';
  $eachbit = '^' . $langtag . '(?:;q=' . $qvalue . ')?(?:,\s*)?(.*)$';

  while (strlen($http_accept_language)) {
    if (preg_match( "/$eachbit/", $http_accept_language, $m)) {
      $tag = $m[1];
      $quality = $m[2];
      if (strlen($quality) == 0) $quality = 1;
      $http_accept_language = $m[3];

      if (array_key_exists($tag, $knownlangs) and $quality > $lastquality) {
	$accept_lang = $knownlangs[$tag];
	$lastquality = $quality;
      }
    } else {
      break;
    }
  }
  return $accept_lang;
}

/*##############################################################
## read/write number of image views (img_view.php)
## this stores the number of views for each image in DB (used in img_view.php)
##############################################################*/

function write_views($val1, $filename)
{
	$query_views=mysql_query("SELECT res, id, date
				FROM {$GLOBALS["table_prefix"]}photos
				WHERE filename='".addslashes($filename)."'
				AND prev_path='".addslashes($val1)."'");
	$no=mysql_fetch_row($query_views);

	if(strlen($no[0])<1)
	{
		$write_view=mysql_query("UPDATE {$GLOBALS["table_prefix"]}photos
					SET res='1', date='$no[2]'
					WHERE id=$no[1]");
	}else
	{
		$update_views=mysql_query("UPDATE {$GLOBALS["table_prefix"]}photos
					SET res=res+1, date='$no[2]'
					WHERE id=$no[1]");
	}
	return $no[0];
}

/*##############################################################
## theme color switch returns color/logo to use...(subfolder preview/index.php!)
## returns the different colors for each theme
##############################################################*/

function color_switch($theme, $choice)
{
	switch($theme)
	{
		case "aqua": /* defaults for aqua style */
		$color="#b0c4de"; /* table bgcolor in subfolder preview */
		$fontcol="#000033"; /* font color in table "thumbnails" view */
		$tablecol="#CCCCCC"; /* table bgcolor in "thumbnails" view */
		$index_logo="index_logo_aqua.jpg"; /* index.php logo */
		break;
		case "colored":
		$color="#F2DF8C";
		$fontcol="#000033";
		$tablecol="#CCCCCC";
		$index_logo="tux5.jpg";
		break;
		case "shadow":
		$color="#000000";
		$fontcol="#CCCCCC";
		$tablecol="#000000";
		$index_logo="index_logo_shadow.jpg";
		break;
		default:
		$color="B3BCDE";
		break;
	}
	if($choice=="logo")
	{
		return $index_logo;
	}
	elseif($choice=="fontcolor")
	{
		return $fontcol;
	}
	elseif($choice=="tablecolor")
	{
		return $tablecol;
	}
	else
	{
		return $color;
	}
}

/*##############################################################
## number of thumbnail pages to create in subfolders
## count the number of pages for each album *_stage_album.php. (thumbnail view)
##############################################################*/

function get_num_pages($number_photos, $number_total)
{
	/* how many pages */
	if($number_photos<$number_total): $page = 1; endif;
	if($number_photos>$number_total): $page = ceil($number_photos/$number_total); endif;
	return $page;
}

/*##############################################################
## check for PHP version (also takes care of different patchlevels and rc's)
## returns the current PHP version to enable disable some features which depend
## on the installed PHP version.
##############################################################*/

function check_php_version($min_version)
{
$is_version=phpversion();

list($v1,$v2,$v3,$v4) = sscanf($is_version,"%d.%d.%d%s");
list($m1,$m2,$m3,$m4) = sscanf($min_version,"%d.%d.%d%s");

	if($v1>$m1)
	return(1);
		elseif($v1<$m1)
		return(0);
	if($v2>$m2)
	return(1);
		elseif($v2<$m2)
		return(0);
	if($v3>$m3)
	return(1);
		elseif($v3<$m3)
		return(0);

	if((!$v4)&&(!$m4))
	return(1);
	if(($v4)&&(!$m4))
	{
		$is_version=strpos($v4,"pl");
		if(is_integer($is_version))
		return(1);
		return(0);
	}
	elseif((!$v4)&&($m4))
	{
		$is_version=strpos($m4,"rc");
		if(is_integer($is_version))
		return(1);
	return(0);
	}
return(0);
}

/*##############################################################
## hit counter statistics
## this one counts and stores the number of visitors
##############################################################*/

function user_counter($ip)
{
/* query ip block time (in minutes)*/
$block_time=read_config('ip_blocking');
$time_now=time();
$time_diff=$block_time*60;

/* delete all ips older then x minutes */
$delete_ips=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}counter_stats
						WHERE UNIX_TIMESTAMP(date)< $time_now-$time_diff");

$query_ip=mysql_query("SELECT ip FROM {$GLOBALS["table_prefix"]}counter_stats");

/* compare stored ips with current ip */
$ips_found=0;
while($ips = mysql_fetch_row($query_ip))
{
	/* still online, update timestamp */
	if($ips[0]==$ip)
	{
		$update_ip=mysql_query("UPDATE {$GLOBALS["table_prefix"]}counter_stats
								SET date=NOW() WHERE ip='$ips[0]'");
		$ips_found++;
	}

}
/* not online, create new entry for current ip */
if($ips_found==0 || empty($ips_found))
{
	$insert_ip=mysql_query("INSERT INTO {$GLOBALS["table_prefix"]}counter_stats (ip) VALUES ('$ip')");
	/* count user in config */
	$all_users=read_config('users');
	$new_users_value=$all_users+1;
	$update_config=mysql_query("UPDATE {$GLOBALS["table_prefix"]}config
				SET option_value='$new_users_value' WHERE option_name='users'");
}
unset($ips_found);
}

/*##############################################################
## current online?
## returns the number of current online users
##############################################################*/

function current_online()
{
$query_online=mysql_query("SELECT ip FROM {$GLOBALS["table_prefix"]}counter_stats");
$online=mysql_num_rows($query_online);
echo $online;
}

/*##############################################################
## read category info (select field)
## used in img_view.php to display all available categories
##############################################################*/

function get_category()
{
$query=mysql_query("SELECT DISTINCT name FROM {$GLOBALS["table_prefix"]}category");
/* create array */
while($rows = mysql_fetch_row($query))
{
	$category_name=$rows[0];
	$category_name_array.="<option value=\"$category_name\">$category_name</option>";
}
echo $category_name_array;
}

/*##############################################################
## count number of photos in subfolder
## returns the number of photos for the current album
##############################################################*/

function num_subfolder_photos($name_value, $path)
{
$query=mysql_query("SELECT id FROM {$GLOBALS["table_prefix"]}photos
					WHERE name='$name_value' AND prev_path='$path'");
$num=mysql_num_rows($query);
echo $num;
}

/*##############################################################
## get date of photo
## returns the date of latest added photo
##############################################################*/

function get_photo_date($name_value, $path)
{
//setlocale (LC_ALL, 'de_DE', 'de');

$date_query=mysql_query("SELECT date FROM {$GLOBALS["table_prefix"]}photos
						WHERE name='$name_value' AND prev_path='$path' ORDER BY date DESC");
$result=mysql_fetch_row($date_query);

$year=substr($result[0],0,4);
$month=substr($result[0],4,2);
$day=substr($result[0],6,2);

$form_date=strftime("%a %e %B %Y", mktime(0,0,0,$month,$day,$year));
echo $form_date;
}

/*##############################################################
## read info (comment/description)
## returns either the description or comment for the photo. used in img_view.php
## and in thumbnail view were it shows the descr. as name: under the thumbnail
##############################################################*/

function read_description($value, $name, $filename, $prev_path)
{
$info=mysql_query("SELECT $value FROM {$GLOBALS["table_prefix"]}photos
					WHERE name='".addslashes($name)."' AND filename='".addslashes($filename)."' AND prev_path='".addslashes($prev_path)."'");
$result=mysql_fetch_row($info);
return $result[0];
}

/*##############################################################
## read config entries
## returns the value for an config entry of choice
##############################################################*/

function read_config($value)
{
$value=mysql_query("SELECT option_value FROM {$GLOBALS["table_prefix"]}config
					WHERE option_name='$value'");
$result=mysql_fetch_row($value);
return $result[0];
}

/*##############################################################
## update config entries
## update the value for an photo entry
##############################################################*/

function update_config($value, $name)
{
$update=mysql_query("UPDATE {$GLOBALS["table_prefix"]}config
					SET option_value='$value'
					WHERE option_name='$name'");
}

/*##############################################################
## write config entries
## write new config entries to linpha_config table
##############################################################*/

function write_config($name, $value)
{
$write=mysql_query("INSERT INTO {$GLOBALS["table_prefix"]}config (option_name, option_value)
					VALUES ('$name','$value')");
}

/*##############################################################
## count number of photos in DB
##############################################################*/

function count_pictures()
{
$number=mysql_query("SELECT COUNT(filename) FROM {$GLOBALS["table_prefix"]}photos");
$count=mysql_fetch_row($number);
return $count[0];
}

/*##############################################################
## thumbnail sub function
## stores thumbnail as blob in DB (linpha_photos)
##############################################################*/

function make_thumbs($prev_path, $entry, $org_width, $org_height, $org_type, $name)
{
	$src_file=$prev_path."/".$entry;

	$src_file = str_replace("'", '\'', $src_file);
	$special_file=0;
	/* take care of avi and mov files (don't let convert/gd run) */
	if($org_type==10 || $org_type==11 || $org_type==15) /* avi/mov/mpg file found */
	{
		$special_file=1;
		$tmp_file="graphics/avi_mov.gif";
	}
	elseif($org_type==222)
	{
		error_log("image is broken or type not supported: name->$entry",0);
	}
	else
	{

		/* create temporary filename (works on all OS) */
		$tmp_file_org = tempnam("/tmp", "$entry");

		/* append .jpg to tmp_file to make sure all filtypes will be saved as jpgs in DB
		(convert only!)*/
		$tmp_file=$tmp_file_org.".jpg";
		unlink("$tmp_file_org");

		/* make use of convert ? */
		$convert=read_config('use_convert');

		$max_width = "120";
		$max_height = "120";

		$div_width  = $org_width  / $max_width;
		$div_height = $org_height / $max_height;

		/* portrait/landscape? */
		if ($div_width >= $div_height)
		{
			$new_width = $max_width;
			$new_height = round($org_height /$div_width);
		}
		else
		{
			$new_width =  round($org_width / $div_height);
			$new_height = $max_height;
		}

		if($convert)
		{
			$command = "convert -border 10x10 -size \"".$new_width."x".$new_height."\" \"$src_file\" -sample \"".$new_width."x".$new_height."\" +profile APP1 \"$tmp_file\"";
			exec($command);
		}
		/* workarround for Mac OSX where convert is usually installed in /sw/bin */
		elseif($convert==true && file_exists("/sw/bin/convert"))
		{
			exec("/sw/bin/convert -border 10x10 -size \"".$new_width."x".$new_height."\" \"$src_file\" -sample \"".$new_width."x".$new_height."\" +profile APP1 \"$tmp_file\"");
		}
		/* make use of the GD library */
		elseif(extension_loaded('gd'))
		{
			/* try to remove php script time limit of 30 sec */
			set_time_limit(0);

			/* try to increase memory_limit */
			ini_set("memory_limit", "64M");

			/* get image type */
			switch($org_type)
			{
				case 1: $image_type=imagecreatefromgif("$src_file"); break;
				case 2: $image_type=imagecreatefromjpeg("$src_file"); break;
				case 3: $image_type=imagecreatefrompng("$src_file"); break;
				default: $image_type=imagecreatefromjpeg("$src_file"); break;
			}

			if ($image_type)
			{
				/* ask config for GD version */
				$gd_current=read_config('gd_version');
				switch($gd_current)
				{
					case ">2":
						$scaled_image=imagecreatetruecolor($new_width,$new_height);
						break;
					case "<2":
						$scaled_image=imagecreate($new_width,$new_height);
						break;
					default:
						$scaled_image=imagecreate($new_width,$new_height);
						break;
				}
				if ($scaled_image && read_config('thumb_quality')==true)
				{
					/* create HQ thumbnails using imagecopyresampled() */
					imagecopyresampled($scaled_image,$image_type,0,0,0,0,
							$new_width,$new_height,
							$org_width,$org_height);
					imagedestroy($image_type);
				}
				elseif($scaled_image)
				{
					imagecopyresized($scaled_image,$image_type,0,0,0,0,
							$new_width,$new_height,
							$org_width,$org_height);
					imagedestroy($image_type);
				}
				switch($org_type)
				{
					case 1: imagegif($scaled_image, "$tmp_file"); break;
					case 2: imagejpeg($scaled_image,"$tmp_file"); break;
					case 3: imagepng($scaled_image, "$tmp_file"); break;
					default: imagejpeg($scaled_image,"$tmp_file"); break;
				}
				imagedestroy($scaled_image);
			}
		} /* end else */
		else
		{
			echo "ERROR, you are missing convert as well as the GD library!!<br>"; /* TODO: lang entry! */
		}
	}

	if($src_file && !empty($tmp_file))
	{
		/* check for magic_quote settings */
		if(get_magic_quotes_runtime()==1)
		{
			$file_data = fread(fopen("$tmp_file", "rb"), filesize("$tmp_file"));
		}
		else
		{
			$file_data = addslashes(fread(fopen("$tmp_file", "rb"), filesize("$tmp_file")));
		}

		$sql = "UPDATE {$GLOBALS["table_prefix"]}photos
							SET thumbnail = '$file_data',
							level = '$special_file'
							WHERE filename = '".addslashes($entry)."'
							AND name='".addslashes($name)."' AND prev_path='".addslashes($prev_path)."'";
		$write = mysql_query($sql);

		if(!$write)
			echo mysql_error();

		if(!$special_file):unlink ("$tmp_file");endif;
		
	}
	else
	{
		echo "image is broken or type not supported<br>"; /* TODO: lang entry! */
	}
	unset($org_type, $file_data);
}

/*##############################################################
## thumbnail creation, using the GD library. GIF is still supported
## because someone may use a GD library before 1.6 ;)
##############################################################*/

function create_thumbs($prev_path, $entry, $name)
{
$src_file="$prev_path/$entry";

unset($filetype);
list($org_width,$org_height,$org_type,$org_size) = getimagesize("$src_file");

/* take care of bad image header */
if (!$org_type >= 1 && !$org_type <= 8)
{
	$entry=strtolower($entry);
	$filetype=explode(".",$entry);

	/* check filetype by file ending*/
    switch($filetype[1])
    	{
			case("jpg"):
            	$org_type=2;
			break;
			case("jpeg"):
            	$org_type=2;
			break;
			case("gif"):
            	$org_type=1;
			break;
			case("png"):
            	$org_type=3;
			break;
			case("avi"):
				$org_type=10;
			break;
			case("mov"):
				$org_type=11;
			break;
			/* mpeg should be detected as type 15 from getimagesize(), but ;-)
			I think 4.3.2 is required*/
			case("mpg"):
				$org_type=15;
			break;
			case("mpeg"):
				$org_type=15;
			break;
			default:
				$org_type=222; // unsupported file found!
			break;
		} /* end switch*/
    /* do it */
	make_thumbs($prev_path, $entry, $org_width, $org_height, $org_type, $name);
}
elseif ($org_type >= 1 && $org_type <= 8)
{
	make_thumbs($prev_path, $entry, $org_width, $org_height, $org_type, $name);
}
elseif($org_type==15)
{
	make_thumbs($prev_path, $entry, $org_width, $org_height, $org_type, $name);
}
else
{
	print("<font color='#FF0000'><strong>FATAL ERROR!<br>Image type not supported, or broken image
				<br>reported type is: $org_type</strong></font>");
}
}

/*##############################################################
## delete obsolete pictures from table photos
##############################################################*/

function del_obsolete_pictures($prev_path, $name)
{

$query=mysql_query("SELECT filename FROM {$GLOBALS["table_prefix"]}photos
					WHERE name='$name' AND prev_path='$prev_path'");

while($data=mysql_fetch_row($query))
{
	if(!file_exists("$prev_path/$data[0]"))
    {
		$remove=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}photos
							WHERE filename='$data[0]'
							AND name='$name' AND prev_path='$prev_path'");
	}
}
}

/*##############################################################
## write changed data (photos) into tables sec_lev_album/third_lev_album.
## writes new albums/folders to the *_level_album table
##############################################################*/

function rw_new_entries($prev_path, $name, $alb_name)
{
if(!empty($prev_path)):$dir_names = dir("$prev_path/");endif;

/* get date of newest picture in table photos once */
$rec_time=mysql_query("SELECT UNIX_TIMESTAMP(date) FROM {$GLOBALS["table_prefix"]}photos
						WHERE name='".addslashes($name)."' AND prev_path='".addslashes($prev_path)."' ORDER BY date DESC");
$db_time=mysql_fetch_row($rec_time);

while($entry=$dir_names->read())
{
	if($entry{0} != '.'  && $entry!="Thumbs.db")
	{
		if(is_dir("$prev_path/$entry"))
		{
			$prev_path = addslashes($prev_path);
			$entry = addslashes($entry);
			$name = addslashes($name);

			$fill_albums_table ="INSERT INTO $alb_name (path, name, prev_alb_name)
						VALUES ('$prev_path/$entry','$entry','$name')";
			$fill_result=mysql_query($fill_albums_table);
		}
		else
		{
			/* TODO: WE NEED A CHECK FOR THE RIGHT FILETYPE (JPG,GIF,PNG) HERE !!*/
			$file_ctime = filectime("$prev_path/$entry");
			//echo $prev_path." : ".$entry." : ".$file_ctime." : ".$db_time[0];
			if($file_ctime > $db_time[0])
			{
				/* take care of mofified photo, e.g. do not create thumbnail twice */
				$img_check=mysql_query("SELECT date FROM {$GLOBALS["table_prefix"]}photos
							WHERE name='".addslashes($name)."' AND prev_path='".addslashes($prev_path)."' AND filename='".addslashes($entry)."'");
				$img_result=mysql_fetch_row($img_check);

				if(!empty($img_result[0]))
				{
					/* OK, just update timestamp and create new thumb later */
					$update_img= ("UPDATE {$GLOBALS["table_prefix"]}photos
								SET date=NOW() WHERE name ='".addslashes($name)."'
								AND prev_path='".addslashes($prev_path)."'
								AND filename='".addslashes($entry)."'");
					$update_result=mysql_query($update_img);
				}
				else
				{
					/* write new entry and create thumb */
					$fill_img = "INSERT INTO {$GLOBALS["table_prefix"]}photos (name, filename, prev_path)
								VALUES ('".addslashes($name)."','".addslashes($entry)."','".addslashes($prev_path)."')";
					$fill_result=mysql_query($fill_img);
				}
				$has_images=1;
				create_thumbs($prev_path, $entry, $name);
			}
			$has_images=1;
		} /* end else */
        } /* end if */
	clearstatcache();
} /* end while */

/* if any pictures found, make entry in sec_lev_album
where name == has_images */
if($has_images==1)
{
	$fill_albums_table ="INSERT INTO $alb_name (path, name, prev_alb_name)
					VALUES ('".addslashes($prev_path)."/".addslashes($entry)."','has_images','".addslashes($name)."')";
	$fill_result=mysql_query($fill_albums_table);
	unset($has_images);
}
$dir_names->close();
/* remove deleted pictures from DB */
del_obsolete_pictures($prev_path, $name);
}

/*##############################################################
## create/delete first level album entries in db
## create all entries for the fisrt level in first_level_album table
##############################################################*/

function first_lev_funct()
{
/* fetch entries */
$data = mysql_query("SELECT UNIX_TIMESTAMP(date), path, name
					FROM {$GLOBALS["table_prefix"]}first_lev_album");
$firstdata =  mysql_fetch_row($data);

clearstatcache();
$prev_dir_mtime = filemtime("albums");

if($prev_dir_mtime >= $firstdata[0])
{
	$get_data = mysql_query("SELECT UNIX_TIMESTAMP(date), path, name
							FROM {$GLOBALS["table_prefix"]}first_lev_album");
	while($read=mysql_fetch_row($get_data))
	{
		if(!file_exists("$read[1]"))
		{
			/*#########################################################
			## think some mainfolders were deleted, now we have to take care of all
			## existing subfolders down to stage 3 as well, as all photos!!!
			#########################################################*/
			/* call required functions */
			sec_lev_funct($read[1], $read[2], $came_from_first=true);
			del_obsolete_pictures($read[1], $read[2]);
		}
	}

	/* save current folder settings (level) for later use */
	$level_query=mysql_query("SELECT name, level FROM {$GLOBALS["table_prefix"]}first_lev_album");
	while($row=mysql_fetch_row($level_query))
	{
		$backup_array[] = array($row[0] => $row[1]);
	}

	/* directory modified !! flush old table */
	$do_delete=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}first_lev_album");
	$dir_names = dir ("albums/");

	/* write new subdir entries to first_lev_album table */
	while($entry=$dir_names->read())
	{
		if($entry != "." && $entry != ".." && $entry != "CVS" && $entry != "index.htm" && $entry != "index.html")
		{
			$entry = addslashes($entry);
			$fill_db ="INSERT INTO {$GLOBALS["table_prefix"]}first_lev_album (path, name, level)
                  		VALUES ('albums/$entry', '$entry', '0')";
			$fill_result=mysql_query($fill_db);
		}
	}
	$dir_names->close();

	/* write back folder settings (level) */
	$counter=0;
	while(list($album_name, $album_level)=each($backup_array[$counter]))
	{
		$update_query=mysql_query("UPDATE {$GLOBALS["table_prefix"]}first_lev_album
									SET level='$album_level'
									WHERE name='$album_name'");
	$counter++;
	}
	unset($backup_array);

} /* end if */
}

/*##############################################################
## create/delete second level album entries
## take care of removed subfolders/mainfolders...
##############################################################*/

function sec_lev_funct($prev_path, $name, $came_from_first)
{
$alb_name="{$GLOBALS["table_prefix"]}sec_lev_album";

/* we have to query the "name" of the album first, to build the full path later. we need this
to recognize same called subfolders in sec_level_album  */
$getname = mysql_query("SELECT name FROM {$GLOBALS["table_prefix"]}sec_lev_album
						WHERE prev_alb_name='$name'
						AND name!='has_images' ORDER BY date DESC");
$is_name=mysql_fetch_row($getname);

/* any entries for that dir ? */
$count = mysql_query("SELECT id FROM {$GLOBALS["table_prefix"]}sec_lev_album
						WHERE prev_alb_name='".addslashes($name)."'
						AND path='$prev_path/$is_name[0]'
						AND name!='has_images' ORDER BY date DESC");
$rows = mysql_num_rows($count);

//error_log( "found that dir: '$prev_path/$is_name[0] has $rows rows...",0);
/* we have existing subfolders AND/OR "has_images" entry in DB*/
if($rows > 0)
{
	$time_result = mysql_query("SELECT UNIX_TIMESTAMP(date), path, name, prev_alb_name
								FROM {$GLOBALS["table_prefix"]}sec_lev_album
								WHERE prev_alb_name='".addslashes($name)."'
								AND name!='has_images'
								ORDER BY date DESC");
	$prev_dir_mtime = filemtime("$prev_path/");

	//error_log(" dirtime of $prev_path/ is: $prev_dir_mtime",0);

	/*##############################################
	## maybe we are called from first_lev_funct(), so take care of subfolders
	## and images to be deleted. (i.e we lost the mainfolder)
	##############################################*/
	if(strlen($prev_dir_mtime)<2)
	{
	/* which subfolder to delete? */
	while($time=mysql_fetch_row($time_result))
	{
		if(!file_exists($time[1]))
		{
			$do_delete=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}sec_lev_album
									WHERE prev_alb_name='$time[3]'");

			/* call third_lev_album to delete all remaining subfolders and photos */
			/* therefore explode some info from path (i.e album name)*/
			$third_name=explode("/",$time[1]);
//error_log( "running line 837 because prev_dir_mtime is >2",0);
			/* let third_lev_alb() know, it has just to delete this path */
			third_lev_funct($time[1], $third_name[2], $call_from_delete=true);
			del_obsolete_pictures($time[1], $third_name[2]);
		}
	} /* end while */

	/* remove the "has_images" entry in table */
	$delete_has_images=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}sec_lev_album
									WHERE name='has_images' AND prev_alb_name='".addslashes($name)."'");
	} /* end if */

	/*##################################################
	## sec_lev_funct() itself has detected a changes,
	## if something is removed take care of all remaining subfolders and photos
	##################################################*/
	$query = mysql_query("SELECT UNIX_TIMESTAMP(date) , path FROM {$GLOBALS["table_prefix"]}sec_lev_album
							WHERE prev_alb_name='".addslashes($name)."'
							AND name!='has_images'ORDER BY date DESC");
	$dummy=mysql_fetch_row($query);

	$is_skew=$prev_dir_mtime-$dummy[0];
//error_log("secstage thinks latest for $dummy[1]  is: $dummy[0] this means a skew of $is_skew",0);
	if(strlen($dummy[0])<2) :$dummy[0]=$prev_dir_time+10;endif;

	if($prev_dir_mtime >= $dummy[0])
	{
		while($time=mysql_fetch_row($time_result))
		{
			if(!file_exists($time[1]))
			{
				/* selected album directory is modified !! */
				/* therefore explode info from path */
				$third_name=explode("/",$time[1]);
//error_log( "running line 868...",0);
				third_lev_funct($time[1], $third_name[2], $call_from_delete=true);
				del_obsolete_pictures($time[1], $third_name[2]);
			}
		}
		/* flush old entries */
		$do_delete=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}sec_lev_album
								WHERE prev_alb_name='".addslashes($name)."'");
//error_log( "running line 876 new entries",0);
		rw_new_entries($prev_path, $name, $alb_name);
	} /* end if */

}
else
{
	/* no subdirs exist/ subdir modified, creating/delete entries! */
	/* prevent rw_new_entries() from call if we found "has_images" and nothing is changed
	/* but make sure to run it, if called by first_lev_funct() */
	$query = mysql_query("SELECT name FROM {$GLOBALS["table_prefix"]}sec_lev_album
						WHERE prev_alb_name='".addslashes($name)."'");
	$result=mysql_fetch_row($query);
	if(!$result[0]=="has_images")
	{
		$delete_has_images=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}sec_lev_album
							WHERE name='has_images' AND prev_alb_name='".addslashes($name)."'");
		/* only if not called by first_lev_album run rw_new_entries()*/
//error_log( "running line 894 new entries",0);
		if(!$came_from_first):rw_new_entries($prev_path, $name, $alb_name); endif;
		unset($came_from_first);
	}else
	{
		/* remove the "has_images" entry in table */
		$delete_has_images=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}sec_lev_album
							WHERE name='has_images' AND prev_alb_name='".addslashes($name)."'");
//error_log( "running line 901 new entries",0);
		/* only if not called by first_lev_album run rw_new_entries()*/
		if(!$came_from_first):rw_new_entries($prev_path, $name, $alb_name); endif;
	}
} /* end else */
} /* end funct */

/*##############################################################
## create third level album entries
##############################################################*/

function third_lev_funct($prev_path, $name, $call_from_delete)
{
$alb_name="{$GLOBALS["table_prefix"]}third_lev_album";

/* we have to query the "name" of the album first, to build the full path later. we need this
to recognize same called subfolders in third_level_album */
$get_name = mysql_query("SELECT name FROM {$GLOBALS["table_prefix"]}third_lev_album
						WHERE prev_alb_name='$name'
						AND name!='has_images'ORDER BY date DESC");
$isname=mysql_fetch_row($get_name);

/* entries for that dir ? */
$count = mysql_query("SELECT id FROM {$GLOBALS["table_prefix"]}third_lev_album
						WHERE prev_alb_name='$name' AND path='$prev_path/$isname[0]'
						AND name!='has_images'ORDER BY date DESC");
$rows = mysql_num_rows($count);

/* prevent from call if we have has_images and nothing is changed
used later in (elseif in this function) */
$query_has_images=mysql_query("SELECT id FROM {$GLOBALS["table_prefix"]}third_lev_album
					WHERE prev_alb_name='$name'
					AND path='$prev_path/'
					AND name='has_images'");
$result_has_images=mysql_num_rows($query_has_images);

//error_log( "found that dir (3 level): '$prev_path/$isname[0] has $rows rows...",0);
/* OK we have existing subfolders for that dir, let's see if something has changed*/
if($rows > 0)
{
	$time_result = mysql_query("SELECT UNIX_TIMESTAMP(date), path, name
								FROM {$GLOBALS["table_prefix"]}third_lev_album
								WHERE prev_alb_name='$name'
								AND name!='has_images'
								ORDER BY date DESC");
	$prev_dir_mtime = filemtime("$prev_path/");

//error_log(" dirtime (3 level) of $prev_path/ is: $prev_dir_mtime",0);
	/*#####################################################
	## maybe we are called from sec_lev_funct() so start delete of obsolete folders
	## this is the case when the subfolder is removed and as a result the
	## $prev_dir_time variable is empty
	#####################################################*/
	if(strlen($prev_dir_mtime)<2)
	{
		while($time = mysql_fetch_row($time_result))
		{
			if(!file_exists($time[1]))
			{
//error_log(" second level wants us to delete: $time[2] where path $prev_path/",0);
				$do_delete=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}third_lev_album
										WHERE name='$time[2]'");
				del_obsolete_pictures($time[1], $time[2]);
			}
		$delete_has_images=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}third_lev_album
										WHERE name='has_images' AND prev_alb_name='$name'");

		} /* end while */
	} /* end if */

	/*##################################################
	## third_lev_funct() itself has detected a changes,
	## if something is removed take care of all remaining subfolders and photos
	##################################################*/
	$query = mysql_query("SELECT UNIX_TIMESTAMP(date), path
						FROM {$GLOBALS["table_prefix"]}third_lev_album
						WHERE path='$prev_path/$isname[0]' AND name != 'has_images'
						ORDER BY date DESC");
	$dummy=mysql_fetch_row($query);

	//$is_skew=$prev_dir_mtime-$dummy[0];
	//error_log("secstage thinks latest for $dummy[1]  is: $dummy[0] this means a skew of $is_skew",0);

	if(strlen($dummy[0])<2): $dummy[0]=$prev_dir_time+100;endif;

	if($prev_dir_mtime >= $dummy[0])
	{
		while($time=mysql_fetch_row($time_result))
		{
			if(!file_exists($time[1]))
			{
//error_log("going to delete $time[1] from third level cause does no longer exist...
//btw found that myself! name was: $name");
				/* selected album directory is modified !! */
        		$do_delete=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}third_lev_album
										WHERE name='$time[2]'");
				del_obsolete_pictures($time[1], $time[2]);
			}
		$delete_has_images=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}third_lev_album
										WHERE name='has_images' AND prev_alb_name='$name'");
		} /* end while */
		/* flush old entries */
		$do_delete=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}third_lev_album
								WHERE prev_alb_name='$name'");
		rw_new_entries($prev_path, $name, $alb_name);
	}

}

/*##########################################################
## we are called from sec_lev_funct() and number of rows==0
## make sure to remove all entries and prevent from running rw_new_entries()
##########################################################*/

elseif($rows==0 && $call_from_delete==true)
{
	//error_log("going to delete name: $name from third level line : 1013");
	/* flush old entries */
	$do_delete=mysql_query("DELETE FROM {$GLOBALS["table_prefix"]}third_lev_album
							WHERE prev_alb_name='$name'");
	unset($call_from_delete);
}

/*#########################################################
## ok there is a whole lotta nothing, even noe has_images
## so run the rw_new_entries...
#########################################################*/

elseif($rows==0 && $result_has_images < "1" )
{
	//error_log("what shall we do with the trunken sailor...",0);
	/* no subdirs exist, creating entries! */
	//error_log("give him one more beer...",0);
		rw_new_entries($prev_path, $name, $alb_name);

} /* end elseif */
}
/*##############################################################
## create forth level album entries (this is slight different from
## the previous ones, since we do NOT expect more subdirs to be here)
##############################################################*/

function forth_lev_funct($prev_path, $name)
{
$dir_names = dir ("$prev_path/");

/* get date of newest picture in table photos once */
$rec_time=mysql_query("SELECT UNIX_TIMESTAMP(date) FROM {$GLOBALS["table_prefix"]}photos
							WHERE name='$name' AND prev_path='$prev_path' ORDER BY date DESC");
$db_time=mysql_fetch_row($rec_time);

	while($entry=$dir_names->read())
	{
		if($entry != "." && $entry != "..")
		{
				/* TODO: WE NEED A CHECK FOR THE RIGHT FILETYPE (JPG,GIF,PNG) HERE !!*/
                $file_ctime = filectime("$prev_path/$entry");

				if($file_ctime > $db_time[0])
				{
					/* take care of mofified photo, e.g. do not create thumbnail twice */
					$img_check=mysql_query("SELECT date FROM {$GLOBALS["table_prefix"]}photos
								WHERE name='$name' AND prev_path='$prev_path' AND filename='$entry'");
					$img_result=mysql_fetch_row($img_check);

					if(!empty($img_result[0]))
					{
						/* OK, just update timestamp and create new thumb later */
						$update_img= ("UPDATE {$GLOBALS["table_prefix"]}photos
									  SET date=NOW() WHERE name ='$name'
									  AND prev_path='$prev_path'
									  AND filename='$entry'");
						$update_result=mysql_query($update_img);
					}
					else
					{
						/* write new entry and create thumb */
						$fill_img = "INSERT INTO {$GLOBALS["table_prefix"]}photos (name, filename, prev_path)
									VALUES ('$name','$entry','$prev_path')";
						$fill_result=mysql_query($fill_img);
					}
				create_thumbs($prev_path, $entry, $name);
				}
        } /* end if */
    clearstatcache();
	} /* end while */

/* remove deleted pictures from DB */
del_obsolete_pictures($prev_path, $name);
}
?>
